#include "Arduino.h"
#include "display.h"
#include <Wire.h>
const uint8_t cisla[] = {

  0b00111111, 

  0b00000110, 

  0b01011011, 

  0b01001111, 

  0b01100110, 

  0b01101101,

  0b01111101,

  0b00000111,

  0b01111111,

  0b01101111,

  0b01110111,

  0b01111100, 

  0b00111001, 

  0b01011110, 

  0b01111001, 

  0b01110001  

}; 
display::display(int pin)
{
Wire.begin();

}

void display::show(int n)
{
   if(n > 9999){
     Wire.beginTransmission(0x27);
  Wire.write(0x00);
  Wire.write(0b01000000);
  Wire.endTransmission();
   Wire.beginTransmission(0x27);
  Wire.write(0x01);
  Wire.write(0b01000000);
  Wire.endTransmission();
   Wire.beginTransmission(0x27);
  Wire.write(0x02);
  Wire.write(0b01000000);
  Wire.endTransmission();
   Wire.beginTransmission(0x27);
  Wire.write(0x03);
  Wire.write(0b01000000);
  Wire.endTransmission();
  return;
    }
  int n1 = n / 1000;
  n = n % 1000;
  int n2 = n/100;
  n = n % 100;
  int n3 = n/10;
  n = n % 10;
  bool writed = false;
  uint8_t towrite;
  if(n1 > 0 || writed){
    writed = true;
    towrite = cisla[n1];
  } else {
    towrite = 0b00000000;
    }
 Wire.beginTransmission(0x27);
  Wire.write(0x00);
  Wire.write(towrite);
  Wire.endTransmission();
  
  if(n2 > 0 || writed){
    writed = true;
    towrite = cisla[n2];
  } else {
    towrite = 0b00000000;
    }
 Wire.beginTransmission(0x27);
  Wire.write(0x01);
  Wire.write(towrite);
  Wire.endTransmission();

  if(n3 > 0 || writed){
    writed = true;
    towrite = cisla[n3];
  } else {
    towrite = 0b00000000;
    }
 Wire.beginTransmission(0x27);
  Wire.write(0x02);
  Wire.write(towrite);
  Wire.endTransmission();

  
 Wire.beginTransmission(0x27);
  Wire.write(0x03);
  Wire.write(cisla[n]);
  Wire.endTransmission();
  }
void display::showmark(int n){
if(n>-1){
    show(n);
    } else if(n < -999) {
      Wire.beginTransmission(0x27);
  Wire.write(0x00);
  Wire.write(0b01000000);
  Wire.endTransmission();
   Wire.beginTransmission(0x27);
  Wire.write(0x01);
  Wire.write(0b01000000);
  Wire.endTransmission();
   Wire.beginTransmission(0x27);
  Wire.write(0x02);
  Wire.write(0b01000000);
  Wire.endTransmission();
   Wire.beginTransmission(0x27);
  Wire.write(0x03);
  Wire.write(0b01000000);
  Wire.endTransmission();
      } else {
Wire.beginTransmission(0x27);
  Wire.write(0x00);
  Wire.write(0b00000000);
  Wire.endTransmission();


        n = -n;
        Serial.println(n);
        int n1 = n / 100;
        
  n = n % 100;
  int n2 = n/10;
  n = n % 10;
  bool writed = false;
  uint8_t towrite;
  if(n1 > 0 || writed){
    
    towrite = cisla[n1];
    if(!writed){
     Wire.beginTransmission(0x27);
  Wire.write(0x00);
  Wire.write(0b01000000);
  Wire.endTransmission();
    }
  writed = true;
  } else {
    towrite = 0b00000000;
    }
 Wire.beginTransmission(0x27);
  Wire.write(0x01);
  Wire.write(towrite);
  Wire.endTransmission();
  
  if(n2 > 0 || writed){
    
    towrite = cisla[n2];
    if(!writed){
    Wire.beginTransmission(0x27);
  Wire.write(0x01);
  Wire.write(0b01000000);
  Wire.endTransmission();
  }
  writed = true;
  } else {
    towrite = 0b00000000;
    Wire.beginTransmission(0x27);
  Wire.write(0x02);
  Wire.write(0b01000000);
  Wire.endTransmission();
    }
 Wire.beginTransmission(0x27);
  Wire.write(0x02);
  Wire.write(towrite);
  Wire.endTransmission();

 Wire.beginTransmission(0x27);
  Wire.write(0x03);
  Wire.write(cisla[n]);
  Wire.endTransmission();

        }
}

void display::showletter(char ch,int pos){
 int chint = (int)ch;
    if(chint < 'G' && chint >= 'A'){
       Wire.beginTransmission(0x27);
  Wire.write((uint8_t)pos);
  Wire.write(cisla[chint - 65 + 10]);
  Wire.endTransmission();
      } else {
        Wire.beginTransmission(0x27);
  Wire.write((uint8_t)pos);
  Wire.write(0b01000000);
  Wire.endTransmission();
        }
}

